/*
 * Ch6b_GetJobList.sql
 * Copyright 2001 Matthew J. Holmes
 */

IF EXISTS (SELECT * FROM sysObjects WHERE ID = Object_Id('Ch6b_GetJobList'))
	DROP PROC Ch6b_GetJobList
GO

CREATE PROC Ch6b_GetJobList
	@Device	VARCHAR50
AS
	DECLARE @UID	int

	/* Find the user */ 
	SELECT @UID = U.UID FROM tbUser U, tbSession S, tbRadio R
		WHERE U.UID = S.UID AND S.RID = R.RID AND R.Device = @Device
	IF @UID IS NULL RETURN 1

	SELECT J.JID, J.CID, J.JobCode, J.JobStatus, J.Description,
		CONVERT(varchar(5), J.JobTime, 108) AS JobTime
	FROM tbJob J WHERE J.UID = @UID ORDER BY J.JobTime
	RETURN 0
GO
