#define INITGUID
 
#include "..\ParseServer\TagParse.h"
#include "..\ParseServer\MTagParse_GUID.h"
//#include "afcore.h"
//#include "afcore_guid.h"
//#ifndef AFPALMOS
//#include <stdio.h>
//#endif

#include "parseevents.h"
#include "sptr.h"
#include "debug.h"


char* g_TagStr = "<Database>"
                   "<Schema>"
                     "<Field>"
                       "Data for field 1"
                     "</Field>"
                     "<Field>"
                       "Data for field 2"
                     "</Field>"
                   "</Schema>"
                   "<Data>"
                     "<Record>"
                       "Data for record 1"
                     "</Record>"
                     "<Record>"
                       "Data for record 2"
                     "</Record>"
                     "<Record>"
                       "Data for record 3"
                     "<Record>"                     
                   "</Data>"
                 "</Database>";

#define MAX_DATA_LEN 512
                 
#ifdef AFPALMOS
UInt32 PilotMain( UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
#else
int main(int argc, char *argv)
#endif  // #ifdef AFPALMOS
{

#ifdef AFPALMOS
	switch (cmd)
	{
	   case sysAppLaunchCmdNormalLaunch:
      {
#endif

         HRESULT hr;
         IPtr<IHost, &IID_IHost> spHost;
         IPtr<IString, &IID_IString> spTagStr;
         IPtr<IString, &IID_IString> spSchemaStart;
         IPtr<IString, &IID_IString> spSchemaEnd;
         IPtr<IString, &IID_IString> spDataStart;
         IPtr<IString, &IID_IString> spDataEnd;
         IPtr<IString, &IID_IString> spRecData;
         IPtr<IString, &IID_IString> spRecStart;
         IPtr<IString, &IID_IString> spRecEnd;
         IPtr<ITagParse, &IID_ITagParse> spTagParse;

         S32 numTagPairs = 0;
         TagParseEvents *pTagParseEvents;

         pCoInitialize();
         pCoGetHost(&spHost);

         pCoCreateStringAnsi(g_TagStr, &spTagStr);
		 
         pCoCreateString(L"<Schema>>", &spSchemaStart);
         pCoCreateString(L"</Schema>", &spSchemaEnd);
         pCoCreateString(L"<Record>", &spRecStart);
         pCoCreateString(L"</Record>", &spRecEnd);
         pCoCreateString(L"<Data>", &spDataStart);
         pCoCreateString(L"</Data>", &spDataEnd);
         
         U32 ulFoundIndex = 0;
 
         hr = spHost->CreateInstance(CLSID_CTagParse, NULL, IID_ITagParse, (void **)&spTagParse);
         if(!SUCCEEDED(hr))
         {
            Debugln("Unable to create TagParse server.");
            return 1;
         }

         pTagParseEvents = new TagParseEvents(spTagParse);

         spTagParse->CountTagPairs(spTagStr, spSchemaStart, spSchemaEnd, numTagPairs);

         spTagParse->CountTagPairs(spTagStr, spRecStart, spRecEnd, numTagPairs);

         Debugln("Num records: %ld", numTagPairs);

         if(SUCCEEDED(hr = spTagParse->ExtractDataByTag(spTagStr, spDataStart, spDataEnd, MAX_DATA_LEN, *(&spRecData))))
         {
            Debug("Record data: ");
            Debugln(spRecData);
         }
         else
         {
            Debugln("Could not extract record data.");
            return 1;
         }


         U32 ulStartIndex = 0;
         U32 ulEndIndex = 0;
         for(int nRecIndex = 0; nRecIndex < numTagPairs; nRecIndex++)
         {
            IString *pData;
            spRecData->FindSubstr(spRecStart, ulStartIndex, -1, &ulStartIndex);

            ulStartIndex += spRecStart->GetLength();

            spRecData->FindSubstr(spRecEnd, ulStartIndex, -1, &ulEndIndex);

            if(SUCCEEDED(spTagParse->ExtractDataByIndex(spRecData, ulStartIndex, ulEndIndex-ulStartIndex, pData)))
            {
               Debug("Record %ld: ", nRecIndex);
               Debugln(pData);
               pData->Release();
            }

            ulEndIndex += spRecEnd->GetLength();
            ulStartIndex = ulEndIndex;

         } 
         
        
         spTagStr.Release();
         spSchemaStart.Release();
         spSchemaEnd.Release();
         spDataStart.Release();
         spDataEnd.Release();
         spRecData.Release();
         spRecStart.Release();
         spRecEnd.Release();
         spHost.Release();
         spTagParse.Release();

         delete pTagParseEvents;

         pCoUninitialize();



#ifdef AFPALMOS
      }
		break; //case sysAppLaunchCmdNormalLaunch

	   default:
		break;
	}
#endif

    return 0;

}


