#include "debug.h"

#ifdef AFPALMOS
#include <unix_stdarg.h>
#else
#include <stdio.h>
#include <stdarg.h>
#endif //AFPALMOS

#ifdef AFPALMOS
#ifndef strcpy
#define strcpy StrCopy
#endif
#ifndef sprintf
#define sprintf StrPrintF
#endif
#ifndef vsprintf
#define vsprintf StrVPrintF
#endif
#ifndef _memset
#define _memset(_dst, _int, _sz) MemSet(_dst, _sz, _int)
#endif
#else //AFPALMOS
#ifndef _memset
#define _memset(_dst, _int, _sz) memset(_dst, _int, _sz)
#endif


#endif

#ifdef _DEBUG

void _Debug(char *format, ...)
{
   char szTemp[512];
   
   va_list args;

   va_start(args, format);
   vsprintf(szTemp, format, args);
   va_end(args);
   
#ifdef AFPALMOS
   pCoTraceAnsi(szTemp);
#else
#if defined(DEBUG_FILE)
   FILE *pFile = NULL;
   pFile = fopen(DEBUG_FILE, "a+");
   if(pFile == NULL)
      return;
   fprintf(pFile, "%s", szTemp);
   fclose(pFile);
#endif
   printf("%s", szTemp);
#endif
}

void _Debugln(char *format, ...)
{
   char szTemp[512];
   
   va_list args;

   va_start(args, format);
   vsprintf(szTemp, format, args);
   va_end(args);
#ifdef AFPALMOS
   pCoTraceAnsi(szTemp);
#else
#if defined(DEBUG_FILE)
   FILE *pFile = NULL;
   pFile = fopen(DEBUG_FILE, "a+");
   if(pFile == NULL)
      return;
   fprintf(pFile, "%s\n", szTemp);
   fclose(pFile);
#endif
   printf("%s\n", szTemp);
#endif
}

void _Debug(IString *msg)
{
#ifdef AFPALMOS
   pCoTrace(msg);
#else
   S32 extractCount;
   CHAR08 *chBuff = new CHAR08[msg->GetLength()+1];
   _memset(chBuff, 0, msg->GetLength()+1);
   msg->ExtractAnsi(chBuff, 0, msg->GetLength(), &extractCount, NULL);
   Debug(chBuff);
   delete [] chBuff;
#endif
}

void _Debugln(IString *msg)
{
#ifdef AFPALMOS
   pCoTrace(msg);
#else
   S32 extractCount;
   CHAR08 *chBuff = new CHAR08[msg->GetLength()+1];
   _memset(chBuff, 0, msg->GetLength()+1);
   msg->ExtractAnsi(chBuff, 0, msg->GetLength(), &extractCount, NULL);
   Debugln(chBuff);
   delete [] chBuff;
#endif
}


CTraceCall::CTraceCall(char *msg)
{
   strcpy(m_szMsg, msg);
   sprintf(m_szOut, "%s: IN", m_szMsg);
   Debugln(m_szOut);
}

CTraceCall::~CTraceCall()
{
   sprintf(m_szOut, "%s: OUT", m_szMsg);
   Debugln(m_szOut);
}


#endif //_DEBUG
